var _elementIDs = ["picalign", "usecss", "removeemptytags", "removemozattrs", "autodetectmusic",
		    "sourceview", "spellcheckonpost", "mp3options", "mp3path", "mp3display"];
var dsPrefs = new PrefsWrapper1("extensions.deepestSender.");
const prefbundle = document.getElementById("prefbundle");

function Init() {
	// Main init function once again. The initPanel thing is for if it is opened in the Preferences
	//	window (Mozilla Suite), or a dialog window holding this stuff (Firefox).
	// In: Nothing.
	// Out: Nothing, but preferences are loaded.
	if (parent.initPanel) {
		parent.initPanel("chrome://deepestsender/content/prefform.xul");
		document.getElementById("uninstallbox").collapsed = false;
		var radionum = document.getElementById("mp3options").value;
		if (radionum > 2) {
			SetBroadcaster("bc_textfile", false);
		} else {
			SetBroadcaster("bc_textfile", true);
		}
	} else {
		document.getElementById("firefoxoptions").collapsed = false;
		document.getElementById("picalign").selectedIndex = dsPrefs.getIntPref("PicAlign"); 
		document.getElementById("usecss").checked = dsPrefs.getBoolPref("UseCSS");
		document.getElementById("removeemptytags").checked = dsPrefs.getBoolPref("RemoveEmptyTags");
		document.getElementById("removemozattrs").checked = dsPrefs.getBoolPref("RemoveMozAttrs");
		document.getElementById("autodetectmusic").checked = dsPrefs.getBoolPref("AutoDetectMusic");
		document.getElementById("sourceview").checked = dsPrefs.getBoolPref("SourceViewDefault");
		document.getElementById("sidebaropen").checked = dsPrefs.getBoolPref("OpenInSidebar");
		document.getElementById("mp3options").selectedIndex = dsPrefs.getIntPref("DetectMethod");
		document.getElementById("mp3path").value = dsPrefs.getCharPref("MP3InfoFile");
		document.getElementById("mp3display").value = dsPrefs.getCharPref("MP3Display");
	}
	if ("@mozilla.org/spellchecker;1" in Components.classes) {
		document.getElementById("spellcheckonpost").disabled = false;
		document.getElementById("spellcheckonpost").checked = dsPrefs.getBoolPref("SpellCheckOnPost");
	}
	if (navigator.platform == "Win32") {
		document.getElementById("registry").disabled = false;
	}
	var windowmanager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	var browser = windowmanager.getMostRecentWindow('navigator:browser');
	if (browser.document.getElementById("foxytunes-statusbar-panel")) {
		document.getElementById("foxytunes").disabled = false;
	}
	if (document.getElementById("mp3options").selectedIndex == 3) {
		SetBroadcaster("bc_textfile", false);
	}
}

function SetBroadcaster(broad, val) {
	// Enables or disables the MP3 textbox options. That is all.
	// In: ID of the broadcaster, and a boolean of whether to disable (true) or enable (false) it.
	// Out: Nothing.
	if (val) {
		document.getElementById("bc_textfile").setAttribute("disabled", val);
	} else {
		document.getElementById("bc_textfile").removeAttribute("disabled");
	}
}

function SaveSettings() {
	// Firefox only - Mozilla Suite magically does it all by itself. This just saves the preferences.
	// In: Nothing.
	// Out: Nothing.
	dsPrefs.setIntPref("PicAlign", document.getElementById("picalign").value);
	dsPrefs.setBoolPref("UseCSS", document.getElementById("usecss").checked);
	dsPrefs.setBoolPref("RemoveEmptyTags", document.getElementById("removeemptytags").checked);
	dsPrefs.setBoolPref("RemoveMozAttrs", document.getElementById("removemozattrs").checked);
	dsPrefs.setBoolPref("AutoDetectMusic", document.getElementById("autodetectmusic").checked);
	dsPrefs.setBoolPref("SpellCheckOnPost", document.getElementById("spellcheckonpost").checked);
	dsPrefs.setBoolPref("SourceViewDefault", document.getElementById("sourceview").checked);
	dsPrefs.setBoolPref("OpenInSidebar", document.getElementById("sidebaropen").checked);
	dsPrefs.setIntPref("DetectMethod", document.getElementById("mp3options").value);
	dsPrefs.setCharPref("MP3InfoFile", document.getElementById("mp3path").value);
	dsPrefs.setCharPref("MP3Display", document.getElementById("mp3display").value);
	window.close();
}

function SetMP3InfoFile(pathobj) {
	var mp3file = FilePicker(prefbundle.getString("ChooseMP3File"),0);
	if (mp3file) {
		pathobj.value = mp3file;
	}
}

