var dateformatter = Components.classes["@mozilla.org/intl/scriptabledateformat;1"].getService(Components.interfaces.nsIScriptableDateFormat);
function OpenHistory(showtree) {
	var splitter = document.getElementById("historysplitter");
	//alert(splitter.getAttribute("checked"));
	if ((showtree) && (showtree.getAttribute("checked") != "true")) {
		splitter.setAttribute("state", "open");
		splitter.collapsed = false;
		LoadHistory();
		showtree.setAttribute("checked", true);
	} else {
		splitter.setAttribute("state", "collapsed");
		splitter.collapsed = true;
		document.getElementById("cmd_history").setAttribute("checked", false);
		if (!isSidebar) {
			var savesecs = dsPrefs.getIntPref("SaveDraftEvery") * 1000;
			dsDraft.loadDraft();
			blogger.saveinterval = setInterval("dsDraft.saveDraft();", savesecs);
		}
		delete blogger.editmode;
		document.getElementById("postbutton").collapsed = false;
		document.getElementById("deletebutton").collapsed = true;
		document.getElementById("savebutton").collapsed = true;
		var midas = document.getElementById("message");
		midas.contentDocument.designMode = "On";
		midas.contentDocument.execCommand("useCSS", false, !dsPrefs.getBoolPref("UseCSS"));
	}
}
function LoadHistory() {
	document.getElementById("historydeck").selectedIndex = 0;
	document.getElementById("hdprogress").value = "Waiting for data...";
	document.getElementById("loadingmeter").mode = "undetermined";
	blogger.httpreq = new XMLHttpRequest();
	//blogger.httpreq.onload = historyLoadHandler;
	blogger.httpreq.onreadystatechange = historyLoadHandler;
	blogger.httpreq.onerror = function() {
		alert("There was an error connecting to the server.");
		blogger.httpreq.abort();
		OpenHistory();
	}
	var currentblog = blogger.blogs[document.getElementById("bloglist").selectedIndex];
	blogger.httpreq.open("GET", currentblog["feed"], true, blogger.username, blogger.password);
	blogger.httpreq.send(null);
}
function historyLoadHandler() {
	switch (blogger.httpreq.readyState) {
		case 4:
			if (blogger.httpreq.status == 200) {
				var feed = blogger.httpreq.responseXML;
				blogger.entries = feed.documentElement.getElementsByTagNameNS("http://purl.org/atom/ns#", "entry");
				document.getElementById("entriestree").view = new treeView();
				document.getElementById("historydeck").selectedIndex = 1;
			} else {
				
			}
			break;
		case 3:
			var downloaded = Math.floor(blogger.httpreq.responseText.length / 1024);
			document.getElementById("hdprogress").value = downloaded + " KB downloaded...";
			break;
	}
}
function treeView() {
  	this.rowCount = blogger.entries.length;
	this.getCellText = function(row,col) {
		if (blogger.entries[row]) {
			switch (col) {
				case "datecol":
					var bloggerdate = blogger.entries[row].getElementsByTagName("issued")[0].textContent;
					var postdate = dateformatter.FormatDate("", dateformatter.dateFormatShort, bloggerdate.substring(0, 4), bloggerdate.substring(5, 7), bloggerdate.substring(8, 10));
					return postdate;
					break;
				case "titlecol":
					return blogger.entries[row].getElementsByTagName("title")[0].textContent;
					break;
			}
		} else {
			return null;
		}
 	}
	this.setTree = function(treebox){ this.treebox = treebox; }
	this.isContainer = function(row){ return false; }
	this.isSeparator = function(row){ return false; }
	this.isSorted = function(row){ return false; }
	this.getLevel = function(row){ return 0; }
	this.getImageSrc = function(row,col){ return null;}
	this.getRowProperties = function(row, props) {
		var draft = blogger.entries[row].getElementsByTagNameNS("http://purl.org/atom-blog/ns#", "draft")[0];
		if (draft.textContent == "true") {
			var aserv = Components.classes["@mozilla.org/atom-service;1"].getService(Components.interfaces.nsIAtomService);
			props.AppendElement(aserv.getAtom("greyedout"));
		}
	}
	this.getCellProperties = function(row,col,props){}
	this.getColumnProperties = function(colid,col,props) {}
}
function showText(treeobj) {
	if (!blogger.editmode) {
		if (!isSidebar) {
			dsDraft.saveDraft();
			clearInterval(blogger.saveinterval);
			delete dsDraft.draftfile;
		}
		blogger.editmode = true;
		document.getElementById("postbutton").collapsed = true;
		document.getElementById("deletebutton").collapsed = false;
		document.getElementById("savebutton").collapsed = false;
	}
	
	var entry = blogger.entries[treeobj.currentIndex];
	var subject = entry.getElementsByTagName("title")[0].textContent;
	
	var event = entry.getElementsByTagName("content")[0];
	var post;
	
	var draft = entry.getElementsByTagNameNS("http://purl.org/atom-blog/ns#", "draft")[0];
	
	if (event.getAttribute("mode") == "escaped") {
		post = event.textContent;
		post = post.replace(/\n/g, "");
		post = post.replace(/<br[\s\/]*?>/g, "\n");
	} else {
		var serializer = new XMLSerializer();
		post = serializer.serializeToString(event.getElementsByTagName("div")[0]);
		// This is stupid. I'd do it more efficiently, but can't figure out the right fucking regexp.
		post = post.replace(/\n/g, "");
		post = post.replace(/<.*?>(.*)<\/div>/gi, "$1");
		post = post.replace(/<br[\s\/]*?>/g, "\n");
	}
	
	if (subject) {
		// Blogger returns titles as about 50 characters with ... at the end if there's no actual title to the post.
		// This is annoying and creates more work for me. I hate you, Blogger.
		if (subject.substr(0, subject.length - 3) != event.textContent.replace(/\n+/g, " ").substr(0, subject.length - 3)) {
			document.getElementById("subject").value = subject;
		} else {
			document.getElementById("subject").value = null;
		}
	}
	
	if (draft) {
		document.getElementById("draftcheck").setAttribute("checked", draft.textContent);
	}
	
	document.getElementById("messagesource").value = post;
	dsMidas.syncNormalTab();
	
	var midas = document.getElementById("message");
	midas.contentDocument.designMode = "On";
	midas.contentDocument.execCommand("useCSS", false, !dsPrefs.getBoolPref("UseCSS"));
}
dsPosts.deletePost = function() {
	
}
